package cz.moneta.test.regression.backoffice.callcenter.jenkinstests;

import cz.moneta.test.dsl.Harness;
import cz.moneta.test.dsl.util.credentials.Keys;
import cz.moneta.test.dsl.util.task.ufo.operations.OperationsTasks;
import cz.moneta.test.harness.annotations.JiraTestCase;
import cz.moneta.test.harness.annotations.TestCase;
import cz.moneta.test.harness.annotations.TestScenario;
import cz.moneta.test.harness.support.auth.Credentials;
import cz.moneta.test.harness.support.auth.Key;
import org.junit.jupiter.api.BeforeAll;

import static cz.moneta.test.harness.annotations.Environment.PPE;
import static cz.moneta.test.harness.annotations.Environment.TST1;

@TestScenario(name = "Load and control detail of client and products on STS701")
public class LoadAndControlDetailOfClientAndProductsOnSTS701 {
    private OperationsTasks operationsTasks;
    private String rcOfExistingClient;

    @BeforeAll
    public void getSetup(Harness harness) {
        operationsTasks = harness.tasks().ufo().operations();
        rcOfExistingClient = harness.getSystemOrConfigValue("cc.debitCardTestsClient.rc");
    }

    @TestCase(name = "Load and control detail of client and products on STS701", environments = {PPE, TST1})
    @JiraTestCase(id = "CC-T2121")
    public void loadAndControlDetailOfClientAndProductsOnSTS701(Harness harness, @Key(Keys.ufo.banka.banker) Credentials credentials) {

        harness.withUfo()
                .openLoginPage()
                .then(operationsTasks.login().withCredentials(credentials))
                .fillSearchInput(rcOfExistingClient)
                .clickSearchClient()
                .onClientDetailsPage()
                .clickAccountList()
                .assertAccountProduct("98-BÚ-FO- KONTO GENIUS /R/")
                .clickDebitCard()
                .checkRcOfHolder(rcOfExistingClient)
                .clickAdcProducts()
                .checkRcInListOfProfilesWithAccessToIb(rcOfExistingClient)
                .clickBackButton()
                .clickInternetBankPasswordDispomodelInProductsTree()
                .clickDetailAdcProduct()
                .checkRcInListOfProfilesWithAccessToIb(rcOfExistingClient)
                .clickBackButton()
                .clickSendingOffers()
                .checkRecordsOfDocumentsForSending();
    }
}
